OGRE: Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase Class Reference

Specialisation of HardwareBufferManager to emulate hardware buffers. More...

`#include <OgreGL3PlusDefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase:
[legend]

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }

## Public Member Functions
| GL3PlusDefaultHardwareBufferManagerBase ()
| ~GL3PlusDefaultHardwareBufferManagerBase ()
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer. More...
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer. More...
virtual void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies. More...
void | _notifyCounterBufferDestroyed (HardwareCounterBuffer *buf)
| Notification that at hardware counter buffer has been destroyed. More...
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed. More...
void | _notifyUniformBufferDestroyed (HardwareUniformBuffer *buf)
| Notification that at hardware uniform buffer has been destroyed. More...
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed. More...
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE. More...
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer. More...
HardwareCounterBufferSharedPtr | createCounterBuffer (size_t sizeBytes, HardwareBuffer::Usage usage, bool useShadowBuffer, const String &name="")
| Create a counter buffer. More...
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware index buffer. More...
HardwareUniformBufferSharedPtr | createUniformBuffer (size_t sizeBytes, HardwareBuffer::Usage usage, bool useShadowBuffer, const String &name="")
| Create a uniform buffer. More...
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Creates a vertex buffer. More...
virtual VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding. More...
virtual VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration. More...
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding. More...
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another. More...
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use. More...
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse. More...

## Detailed Description

Specialisation of HardwareBufferManager to emulate hardware buffers.

Remarks
  You might want to instantiate this class if you want to utilise classes like MeshSerializer without having initialised the rendering system (which is required to create a 'real' hardware buffer manager).

## Member Enumeration Documentation

## ◆ BufferLicenseType

enum Ogre::v1::HardwareBufferManagerBase::BufferLicenseType
| inherited

Enumerator
BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

## Constructor & Destructor Documentation

## ◆ GL3PlusDefaultHardwareBufferManagerBase()

Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase::GL3PlusDefaultHardwareBufferManagerBase | ( |  | ) |

## ◆ ~GL3PlusDefaultHardwareBufferManagerBase()

Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase::~GL3PlusDefaultHardwareBufferManagerBase | ( |  | ) |

## Member Function Documentation

## ◆ _forceReleaseBufferCopies() [1/2]

virtual void Ogre::v1::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) |
| virtualinherited

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::_forceReleaseBufferCopies().

## ◆ _forceReleaseBufferCopies() [2/2]

virtual void Ogre::v1::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) |
| virtualinherited

Internal method that forces the release of copies of a given buffer.

Remarks
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters

  sourceBuffer | The source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

Reimplemented in Ogre::v1::HardwareBufferManager.

## ◆ _freeUnusedBufferCopies()

virtual void Ogre::v1::HardwareBufferManagerBase::_freeUnusedBufferCopies | ( | void |  | ) |
| virtualinherited

Free all unused vertex buffer copies.

Remarks
  This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::_freeUnusedBufferCopies().

## ◆ _notifyCounterBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyCounterBufferDestroyed | ( | HardwareCounterBuffer * | buf | ) |
| inherited

Notification that at hardware counter buffer has been destroyed.

Referenced by Ogre::v1::HardwareBufferManager::_notifyConterBufferDestroyed().

## ◆ _notifyIndexBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) |
| inherited

Notification that a hardware index buffer has been destroyed.

Referenced by Ogre::v1::HardwareBufferManager::_notifyIndexBufferDestroyed().

## ◆ _notifyUniformBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyUniformBufferDestroyed | ( | HardwareUniformBuffer * | buf | ) |
| inherited

Notification that at hardware uniform buffer has been destroyed.

Referenced by Ogre::v1::HardwareBufferManager::_notifyUniformBufferDestroyed().

## ◆ _notifyVertexBufferDestroyed()

void Ogre::v1::HardwareBufferManagerBase::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) |
| inherited

Notification that a hardware vertex buffer has been destroyed.

Referenced by Ogre::v1::HardwareBufferManager::_notifyVertexBufferDestroyed().

## ◆ _releaseBufferCopies()

virtual void Ogre::v1::HardwareBufferManagerBase::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) |
| virtualinherited

Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

Parameters

  forceFreeUnused | If `true`, free all unused temporary buffers. If `false`, auto detect and free all unused temporary buffers based on temporary buffers utilization.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::_releaseBufferCopies().

## ◆ allocateVertexBufferCopy()

virtual HardwareVertexBufferSharedPtr Ogre::v1::HardwareBufferManagerBase::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false`
| ) |  |
| virtualinherited

Allocates a copy of a given vertex buffer.

Remarks
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters

  sourceBuffer | The source buffer to use as a copy.
  licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  copyData | If `true`, the current data is copied as well as the structure of the buffer/

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::allocateVertexBufferCopy().

## ◆ createCounterBuffer()

HardwareCounterBufferSharedPtr Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase::createCounterBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer,
|  | const String & | name = `""`
| ) |  |
| virtual

Create a counter buffer.

Implements Ogre::v1::HardwareBufferManagerBase.

## ◆ createIndexBuffer()

HardwareIndexBufferSharedPtr Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) |  |
| virtual

Create a hardware index buffer.

Implements Ogre::v1::HardwareBufferManagerBase.

## ◆ createUniformBuffer()

HardwareUniformBufferSharedPtr Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase::createUniformBuffer | ( | size_t | sizeBytes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer,
|  | const String & | name = `""`
| ) |  |
| virtual

Create a uniform buffer.

Implements Ogre::v1::HardwareBufferManagerBase.

## ◆ createVertexBuffer()

HardwareVertexBufferSharedPtr Ogre::v1::GL3PlusDefaultHardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) |  |
| virtual

Creates a vertex buffer.

Implements Ogre::v1::HardwareBufferManagerBase.

## ◆ createVertexBufferBinding()

virtual VertexBufferBinding* Ogre::v1::HardwareBufferManagerBase::createVertexBufferBinding | ( | void |  | ) |
| virtualinherited

Creates a new VertexBufferBinding.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::createVertexBufferBinding().

## ◆ createVertexDeclaration()

virtual VertexDeclaration* Ogre::v1::HardwareBufferManagerBase::createVertexDeclaration | ( | void |  | ) |
| virtualinherited

Creates a new vertex declaration.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::createVertexDeclaration().

## ◆ destroyVertexBufferBinding()

virtual void Ogre::v1::HardwareBufferManagerBase::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) |
| virtualinherited

Destroys a VertexBufferBinding.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::destroyVertexBufferBinding().

## ◆ destroyVertexDeclaration()

virtual void Ogre::v1::HardwareBufferManagerBase::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) |
| virtualinherited

Destroys a vertex declaration.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::destroyVertexDeclaration().

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ registerVertexBufferSourceAndCopy()

virtual void Ogre::v1::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy
| ) |  |
| virtualinherited

Registers a vertex buffer as a copy of another.

Remarks
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::registerVertexBufferSourceAndCopy().

## ◆ releaseVertexBufferCopy()

virtual void Ogre::v1::HardwareBufferManagerBase::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| virtualinherited

Manually release a vertex buffer copy for others to subsequently use.

Remarks
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters

  bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::releaseVertexBufferCopy().

## ◆ touchVertexBufferCopy()

virtual void Ogre::v1::HardwareBufferManagerBase::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) |
| virtualinherited

Tell engine that the vertex buffer copy intent to reuse.

Remarks
  Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters

  bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

Reimplemented in Ogre::v1::HardwareBufferManager.

Referenced by Ogre::v1::HardwareBufferManager::touchVertexBufferCopy().

The documentation for this class was generated from the following file:

- OgreGL3PlusDefaultHardwareBufferManager.h